﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace МеиодПотенциаоловПоМинимальному_Элементу
{
    internal class Decision
    {
        public static int m; // Количество поставщиков
        public static int n; // Количесвтво потребителей
        public static int[,] matr; //  Матрица затрат на хранение и производство продукции
        public static int[] mMatr; // Матрица мощности поставщиков
        public static int[] nMatr; // Матрица спроса потребителей
        public void calculation() // Расчёт функции и заключения договоров
        {
            bool[,] Filled = new bool[mMatr.Length, nMatr.Length]; // Массив для пометки клеток куда сделана поставка
            int[,] divisionArray = new int[mMatr.Length, nMatr.Length]; // Распределение поставок
            int[,] matrFirst = new int[mMatr.Length, nMatr.Length]; ; // Матрица для первоначального распределения
            Array.Copy(matr,matrFirst, matr.Length);
            int[] M = new int[mMatr.Length]; // Массив для мощности поставщиков в первоначальном распределение
            int[] N = new int[nMatr.Length]; // Массив для спроаса потребителей в первоначальном распределение
            Array.Copy(mMatr, M, mMatr.Length);
            Array.Copy(nMatr, N, nMatr.Length);
            int F = 0; // Значение целевой функции
            int sum = 1; // Сумма мощности поставщиков
            // Первоначальное распределение по минимальному элементу
            while (sum != 0) // Если мощность поставщиков равна 0, то цикл прекратится
            {
                int min = GetMaxMatr(matr);
                int iMin = 0;
                int jMin = 0;
                for (int i = 0; i < mMatr.Length; i++)
                {
                    for (int j = 0; j < nMatr.Length; j++)
                    {
                        if (matrFirst[i, j] <= min && matrFirst[i, j] != 0) // Если наименьшая и не равна 0 (ещё не делали поставку)
                        {
                            min = matrFirst[i, j];
                            iMin = i;
                            jMin = j;
                        }
                    }
                }
                matrFirst[iMin, jMin] = 0; // Зануляем самый минимальный элемент
                if (M[iMin] > 0 && N[jMin] > 0)
                {
                    if (N[jMin] < M[iMin]) // Если спрос меньше предложения
                    {
                        F += matr[iMin, jMin] * N[jMin];
                        divisionArray[iMin, jMin] = N[jMin];
                        Filled[iMin, jMin] = true;
                        M[iMin] -= N[jMin];
                        N[jMin] = 0;
                    }
                    else if(N[jMin] > M[iMin]) // Если спрос больше предложения
                    {
                        F += matr[iMin, jMin] * M[iMin];
                        divisionArray[iMin, jMin] = M[iMin];
                        Filled[iMin, jMin] = true;
                        N[jMin] -= M[iMin];
                        M[iMin] = 0;
                    }
                    else
                    {
                        F += matr[iMin, jMin] * M[iMin];
                        divisionArray[iMin, jMin] = M[iMin];
                        Filled[iMin, jMin] = true;
                        N[jMin] = 0;
                        M[iMin] = 0;
                    }
                }
                sum = 0;
                for(int i = 0; i < M.Length; i++) // Подсчёт суммы мощности поставщиков
                {
                    sum += M[i];
                }
            }
            degeneracy(divisionArray, Filled, M.Length, N.Length); // Проверка на вырожденность
            bool check; // Оптимальность (false - не оптимальна, true - оптимальна)
            check = OptimalityCheck(divisionArray, Filled); // Расчёт и проверка на оптимальность
            if (!check) // Если не оптимальна
            {
                while (check != true)
                {
                    F = 0;
                    for (int i = 0; i < mMatr.Length; i++)
                    {
                        for (int j = 0; j < nMatr.Length; j++)
                        {
                            if (divisionArray[i, j] > 0)
                            {
                                if (nMatr[j] < mMatr[i])
                                {
                                    F += matr[i, j] * divisionArray[i, j];
                                }
                                else
                                {
                                    F += matr[i, j] * divisionArray[i, j];
                                }
                            }
                        }
                    }
                    check = OptimalityCheck(divisionArray, Filled);
                    OptimalityCheck(divisionArray, Filled);
                }
            }
            FileWork.SaveNameFile();
            FileWork.ShowResult(F, divisionArray);
        }
        public static int GetMaxMatr(int[,] matr)
        {
            int max = 0;
            for(int i = 0; i < matr.GetLength(0); i++)
            {
                for (int j = 0; j < matr.GetLength(1); j++)
                {
                    if(max < matr[i, j])
                    {
                        max = matr[i, j];
                    }
                }
            }
            return max;
        }
        public static void degeneracy(int[,] divisionArray, bool[,] Filled, int m, int n) // Проверка на вырожденность
        {
            int kol = 0; // Количество заполненных клеток
            for(int i = 0; i < Filled.GetLength(0); i++) // Подсчёт количества заполненых клеток
            {
                for (int j = 0; j < Filled.GetLength(1); j++)
                {
                    if (Filled[i, j] == true)
                    {
                        kol++;
                    }
                }
            }
            if (m + n - 1 != kol) // Если вырождена
            {
                int[,] matrProverka = new int[matr.GetLength(0), matr.GetLength(1)];
                Array.Copy(matr, matrProverka, matr.Length);
                while (true)
                {
                    int min = GetMaxMatr(matr);
                    int iMin = 0;
                    int jMin = 0;
                    for (int i = 0; i < mMatr.Length; i++)
                    {
                        for (int j = 0; j < nMatr.Length; j++)
                        {
                            if (!Filled[i, j])
                            {
                                if (matrProverka[i, j] <= min)
                                {
                                    min = matr[i, j];
                                    iMin = i;
                                    jMin = j;
                                }
                            }
                        }
                    }
                    Filled[iMin, jMin] = true; // Делаем поставку в минимальный элемент
                    int[] v = new int[mMatr.Length]; // Дополнительный столбец v
                    int[] u = new int[nMatr.Length]; // Дополнительная строка u
                    bool[] vbool = new bool[mMatr.Length];
                    bool[] ubool = new bool[nMatr.Length];
                    u[0] = 0; // Пусть u1 = 0
                    ubool[0] = true;
                    bool proverka = proverkaDzk(ref v, ref u, ref vbool, ref ubool, Filled);
                    if(proverka == false)
                    {
                        matrProverka[iMin, jMin] = GetMaxMatr(matr);
                        Filled[iMin, jMin] = false; // Делаем поставку в минимальный элемент
                    }
                    else
                    {
                        break;
                    }
                }
            }
        }
        public static bool proverkaDzk(ref int[] v, ref int[] u, ref bool[] vbool, ref bool[] ubool, bool [,] Filled) // 2 этап: Для заполненых клеток
        {
            for (int i = 0; i < mMatr.Length; i++) // Простановка потенциалов в 1 столбце
            {
                if (Filled[i, 0])
                {
                    v[i] = matr[i, 0];
                    vbool[i] = true;
                }
            }
            bool checkV = true; // Переменная для выхода из цикла (true - если есть непроставленный потенциал в строке U)
            bool checkU = true; // Переменная для выхода из цикла (true - если есть непроставленный потенциал в столбце V)
            int t = 0;
            while (checkV || checkU) // Простановка потенциалов во всей таблице
            {
                for (int i = 0; i < mMatr.Length; i++) // Заполнение сверху вниз
                {
                    for (int j = 1; j < nMatr.Length; j++)
                    {
                        if (Filled[i, j])
                        {
                            if (ubool[j])
                            {
                                v[i] = matr[i, j] - u[j];
                                vbool[i] = true;
                            }

                            if (vbool[i])
                            {
                                u[j] = matr[i, j] - v[i];
                                ubool[j] = true;
                            }
                        }
                    }
                }
                checkU = false; // Переменная для выхода из цикла
                for (int i = 0; i < ubool.Length; i++) // Проверка на наличие не правставленных потенциалов в строке U
                {
                    if (ubool[i] == false)
                    {
                        checkU = true;
                        break;
                    }
                }
                checkV = false; // Переменная для выхода из цикла
                for (int i = 0; i < vbool.Length; i++) // Проверка на наличие не правставленных потенциалов в столбце V
                {
                    if (vbool[i] == false)
                    {
                        checkV = true;
                        break;
                    }
                }
                if (checkV || checkU)
                {
                    for (int k = mMatr.Length - 1; k >= 0; k--) // Заполнение снизу вверх
                    {
                        for (int p = nMatr.Length - 1; p >= 0; p--)
                        {
                            if (Filled[k, p])
                            {
                                if (ubool[p])
                                {
                                    v[k] = matr[k, p] - u[p];
                                    vbool[k] = true;
                                }

                                if (vbool[k])
                                {
                                    u[p] = matr[k, p] - v[k];
                                    ubool[p] = true;
                                }
                            }
                        }
                    }
                }
                t++;
                if(t > 10)
                {
                    return false;
                }
            }
            return true;
        }
        static bool OptimalityCheck(int[,] divisionArray, bool[,] Filled) // Расчёт ДЗК, ДПК, проверка на оптимальность
        {
            int[] v = new int[mMatr.Length]; // Дополнительный столбец v
            int[] u = new int[nMatr.Length]; // Дополнительная строка u
            bool[] vbool = new bool[mMatr.Length];
            bool[] ubool = new bool[nMatr.Length];
            u[0] = 0; // Пусть u1 = 0
            ubool[0] = true;
            bool proverka = proverkaDzk(ref v, ref u, ref vbool,ref ubool, Filled);
            int[,] delta = new int[mMatr.Length, nMatr.Length]; // Нахождение дельты ДПК
            for (int i = 0; i < mMatr.Length; i++)
            {
                for (int j = 0; j < nMatr.Length; j++)
                {
                    if (!Filled[i, j])
                    {
                        delta[i, j] = v[i] + u[j] - matr[i, j];
                    }
                }
            }
            bool check = false; // Переменная для хранения значения оптимальности
            for (int i = 0; i < delta.GetLength(0); i++) // Если есть дельта > 0, то решение не оптимально
            {
                for(int j = 0; j < delta.GetLength(1); j++)
                {
                    if (delta[i, j] > 0)
                    {
                        check = true;
                        break;
                    }
                }
            }
            if (!check) // Если нету дельта > 0, то решение оптимально
            {
                return true;
            }
            int max = delta[0, 0]; // Переменная для подсчёта максимальная дельта
            int iMax = 0;
            int jMax = 0;
            for (int i = 0; i < mMatr.Length; i++) // Нахождение максимальной дельты
            {
                for (int j = 0; j < nMatr.Length; j++)
                {
                    if (delta[i, j] > max)
                    {
                        max = delta[i, j];
                        iMax = i;
                        jMax = j;
                    }
                }
            }
            Console.WriteLine();
            for (int i = 0; i < mMatr.Length; i++) // Вывод таблицы распределений, где 1 - значит в клетку сделана поставка, 0 - в клетку не сделана поставка
            {
                for (int j = 0; j < nMatr.Length; j++)
                {
                    if (Filled[i, j])
                    {
                        Console.Write(1 + "\t");
                    }
                    else
                    {
                        Console.Write(0 + "\t");
                    }
                }
                Console.WriteLine();
            }
            string[] cycleArray = cycle(Filled, iMax, jMax); // Построение цикла перераспределения
            // Нахождение x = min(-x)
            int iMin = Convert.ToInt32(cycleArray[1].Substring(0, 1)); 
            int jMin = Convert.ToInt32(cycleArray[1].Substring(1, 1));
            int min = divisionArray[iMin, jMin];
            for (int i = 3; i < cycleArray.Length; i += 2)
            {
                iMin = Convert.ToInt32(cycleArray[i].Substring(0, 1));
                jMin = Convert.ToInt32(cycleArray[i].Substring(1, 1));
                if (divisionArray[iMin, jMin] < min)
                {
                    min = divisionArray[iMin, jMin];
                }
            }
            // Прибавление x к первому +z
            int indexI = Convert.ToInt32(cycleArray[0].Substring(0, 1));
            int jndexJ = Convert.ToInt32(cycleArray[0].Substring(1, 1));
            divisionArray[indexI, jndexJ] += min;
            if (divisionArray[indexI, jndexJ] > 0)
            {
                Filled[indexI, jndexJ] = true;
            }
            // Выполнение остального распределения
            for (int c = 1; c < cycleArray.Length; c++)
            {
                int i = Convert.ToInt32(cycleArray[c].Substring(0, 1));
                int j = Convert.ToInt32(cycleArray[c].Substring(1, 1));
                if (c % 2 == 0)
                {
                    divisionArray[i, j] += min;
                    if (divisionArray[i, j] > 0)
                    {
                        Filled[i, j] = true;
                    }
                }
                else
                {
                    divisionArray[i, j] -= min;
                    if (divisionArray[i, j] == 0)
                    {
                        Filled[i, j] = false;
                    }
                }
            }
            return false;
        }
        static string[] cycle(bool[,] Filled, int iMax, int jMax) // Построение цикла перераспределений
        {
            string[] array = new string[1];
            array[0] = Convert.ToString(iMax) + Convert.ToString(jMax);
            for (int i = 0; i < matr.GetLength(1); i++) // Нахождение цикла перераспределения
            {
                if (Filled[i, jMax] == true)
                {
                    for (int j = 0; j < matr.GetLength(0); j++)
                    {
                        if (Filled[iMax, j] == true)
                        {
                            if (Filled[i, j] == true)
                            {
                                Array.Resize(ref array, array.Length + 3);
                                array[1] = Convert.ToString(i) + Convert.ToString(jMax);
                                array[2] = Convert.ToString(i) + Convert.ToString(j);
                                array[3] = Convert.ToString(iMax) + Convert.ToString(j);
                                goto m1;
                            }
                        }
                    }
                }
            }
            for (int i = 0; i < matr.GetLength(1); i++)
            {
                if (Filled[i, jMax] == true)
                {
                    for (int j = 0; j < matr.GetLength(0); j++)
                    {
                        if (Filled[i, j] == true)
                        {
                            for (int p = 0; p < matr.GetLength(0); p++)
                            {
                                if (Filled[p, j] == true)
                                {
                                    for (int m = 0; m < matr.GetLength(1); m++)
                                    {
                                        if (Filled[p, m] == true)
                                        {
                                            for (int q = 0; q < matr.GetLength(0); q++)
                                            {
                                                if (Filled[q, m] == true)
                                                {
                                                    if (Filled[i, j] == true)
                                                    {
                                                        Array.Resize(ref array, array.Length + 5);
                                                        array[1] = Convert.ToString(i) + Convert.ToString(jMax);
                                                        array[2] = Convert.ToString(i) + Convert.ToString(j);
                                                        array[3] = Convert.ToString(p) + Convert.ToString(j);
                                                        array[4] = Convert.ToString(p) + Convert.ToString(m);
                                                        array[5] = Convert.ToString(q) + Convert.ToString(m);
                                                        goto m1;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        m1: return array;
        }
    }
}
