﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Нахождение_критического_пути
{
    internal class Decision
    {
        public int[,] work; // Список дуг (работ) и их продолжительность
        public string[] path; // Список путей
        public int[] F; // Продолжительность для каждого пути
        public int maxF; // Максимальная продолжительность
        public int start;
        public void ShowVhodData()
        {
            Console.WriteLine("Входные данные:");
            Console.WriteLine("Работа | Продолжительность");
            for (int i = 0; i < work.GetLength(0); i++)
            {
                Console.WriteLine(work[i,0] + " -- " + work[i, 1] + "\t\t" + work[i,2]);
            }
        }
        public int GetStart() // Метод для поиска начальной точки (eсли нет таких дуг, которые бы входили в данную точку, то она начальная)
        {
            int start = 0; // Начальная точка
            for(int i = 0; i < work.GetLength(0); i++)
            {
                start = work[i,0];
                int k = 0; // Количество дуг, которые заканчиваются данной точкой
                for(int j = 0; j < work.GetLength(0); j++)
                {
                    if(work[j,1] == start) // Если дуга заканчивается этой точкой
                    {
                        k++;
                    }
                }
                if(k == 0) // Если нет таких дуг, которые бы входили в данную точку, то она начальная
                {
                    break;
                }
            }
            return start;
        }
        public void CalculatePathes() // Формирование путей и подсчёт F
        {
            path = new string[0];
            F = new int[0];
            for (int i = 0; i < work.GetLength(0); i++)
            {
                if(work[i,0] == start)
                {
                    Array.Resize(ref path, path.Length + 1);
                    path[path.Length - 1] = Convert.ToString(start) + " - " + Convert.ToString(work[i, 1]);
                    Array.Resize(ref F, F.Length + 1);
                    F[F.Length - 1] = GetDuration(0, work[i, 0], work[i, 1], work);
                    GetNextPath(work[i, 1]); // Переход к следующей точки
                }
            }
        }
        public int GetDuration(int F, int str, int end, int[,] w) // Метод для подсчёта продолжительности работ (str - начальная точка, end - конечная)
        {
            int summa = 0; // Сумма продолжительности, которую нужно будет прибавить к существующей
            for(int i = 0; i < work.GetLength(0); i++)
            {
                if(w[i,0] == str && w[i, 1] == end)
                {
                    summa = w[i, 2];
                }
            }
            return F + summa;
        }
        public void GetNextPath(int str) // Определение следующей точки
        {
            int k = 0; // Количество точек в которые можно попасть из исходной
            string lastPath = ""; // Переменная, котрая хранит предыдущий путь перед ветвлением
            int lastF = 0; // Переменная, котрая хранит предыдущее значение F перед ветвлением
            for (int i = 0; i < work.GetLength(0); i++)
            {
                if (work[i, 0] == str && k > 0) // Если начальная точка встречается 2 и более раз
                {
                    Array.Resize(ref path, path.Length + 1);
                    path[path.Length - 1] = lastPath + " - " + Convert.ToString(work[i, 1]);
                    Array.Resize(ref F, F.Length + 1);
                    F[F.Length - 1] = GetDuration(lastF, work[i, 0], work[i, 1], work);
                    GetNextPath(work[i, 1]); // Снова проверяем наличие следующего пути
                    k++;
                }
                if (work[i, 0] == str && k == 0)
                {
                    lastPath = path[path.Length - 1]; // Запоминаем предыдущее значение
                    lastF = F[F.Length - 1]; // Запоминаем предыдущее значение
                    path[path.Length - 1] = path[path.Length - 1] + " - " + Convert.ToString(work[i, 1]);
                    F[F.Length - 1] = GetDuration(F[F.Length - 1], work[i, 0], work[i, 1], work);
                    GetNextPath(work[i, 1]); // Снова проверяем наличие следующего пути
                    k++;
                }
            }
        }
        public int FindCriticalPath() // Метод для нахождения макcимальной F
        {
            int max = 0;
            for(int i = 0; i < F.Length; i++)
            {
                if(max <= F[i])
                {
                    max = F[i];
                }
            }
            return max;
        }
    }
}
