﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ПервоначальноеРаспределениеПоМинимальному
{
    internal class FileWork
    {
        public static string pathStart; // Путь к исходному файлу
        public static string pathEnd; // Путь к конечному файлу
        public void VvodNameFile()
        {
            char otv; // Переменная для диалога
            while (true)
            {
                Console.WriteLine("После нажатия Enter, Вам необходимо указать csv файл где хранятся входные данные");
                Console.ReadKey();
                OpenFileDialog OD = new OpenFileDialog();
                OD.DefaultExt = ".csv";
                OD.Filter = "Text documents (.csv)|*.csv";
                if (OD.ShowDialog() == DialogResult.OK)
                {
                    pathStart = OD.FileName;
                    break;
                }
                else
                {
                    while (true)
                    {
                        try
                        {
                            Console.Write("\nЖелаете повторить выбор входных данных?\nДа(Y)/Нет(N)\nОтвет: ");
                            otv = Convert.ToChar(Console.ReadLine());
                            break;
                        }
                        catch
                        {
                            Console.WriteLine("Введены некорректные данные!");
                        }
                    }
                    if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                    {
                        return;
                    }
                }
            }
        }
        public static void SaveNameFile() // Определение файла для вывода результатов
        {
            char otv; // Переменная для диалога с пользователем
            while (true)
            {
                Console.WriteLine("После нажатия Enter, Вам необходимо указать csv файл куда будет сохранён результат");
                Console.ReadKey();
                SaveFileDialog OD = new SaveFileDialog();
                OD.DefaultExt = ".csv";
                OD.Filter = "Text documents (.csv)|*.csv";
                if (OD.ShowDialog() == DialogResult.OK)
                {
                    pathEnd = OD.FileName;
                    break;
                }
                else
                {
                    while (true)
                    {
                        try
                        {
                            Console.Write("\nЖелаете повторить выбор файла?\nДа(Y)/Нет(N)\nОтвет: ");
                            otv = Convert.ToChar(Console.ReadLine());
                            break;
                        }
                        catch
                        {
                            Console.WriteLine("Введены некорректные данные!");
                        }
                    }
                    if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                    {
                        return;
                    }
                }
            }
        }
        public void GetData() // Взятие входных данных из файла
        {
            var lines = File.ReadAllLines(pathStart);
            string[][] text = new string[lines.Length][];
            for (int i = 0; i < text.Length; i++)
            {
                text[i] = lines[i].Split(';');
            }
            Decision.m = text.Length - 1;
            Decision.n = text[text.Length - 1].Length - 1;
            Decision.matrxA = new int[Decision.m, Decision.n];
            Decision.mMatr = new int[Decision.m];
            Decision.nMatr = new int[Decision.n];
            int j = 0;
            int k;
            foreach (string[] line in text)
            {
                k = 0;
                foreach (string s in line)
                {
                    if (j == 0 && k != 0)
                    {
                        Decision.nMatr[k - 1] = Convert.ToInt32(s);
                    }
                    else if (k == 0 && j != 0)
                    {
                        Decision.mMatr[j - 1] = Convert.ToInt32(s);
                    }
                    else if (j != 0 && k != 0)
                    {
                        Decision.matrxA[j - 1, k - 1] = Convert.ToInt32(s);
                    }
                    k++;
                }
                j++;
            }
        }
        public bool Proverka() // Проверка входных данных
        {
            var lines = File.ReadAllLines(pathStart);
            string[][] text = new string[lines.Length][];
            for (int i = 0; i < text.Length; i++)
            {
                text[i] = lines[i].Split(';');
            }
            int j = 0;
            int k;
            foreach (string[] line in text)
            {
                k = 0;
                foreach (string s in line)
                {
                    try
                    {
                        if (j != 0 && k != 0)
                        {
                            if (Convert.ToInt32(s) <= 0)
                            {
                                Console.WriteLine("В таблицы распределений, не могут быть отрицательные значения и ноль");
                                return true;
                            }
                        }
                        k++;
                    }
                    catch
                    {
                        Console.WriteLine("Во входных данных присутствуют некоректные данные, исправьте их и попробуйте снова");
                        return true;
                    }
                }
                j++;
            }
            return false;
        }
        public void Record(int F, int[,] divisionArray) // Запись данных в csv файл
        {
            File.AppendAllText(pathEnd, "F = ;" + F + " у.д.е.;", Encoding.UTF8);
            File.AppendAllText(pathEnd, Environment.NewLine);
            File.AppendAllText(pathEnd, "Заключение договоров", Encoding.UTF8);
            File.AppendAllText(pathEnd, Environment.NewLine);
            for (int i = 0; i < Decision.mMatr.Length; i++)
            {
                for (int j = 0; j < Decision.nMatr.Length; j++)
                {
                    if (divisionArray[i, j] > 0)
                    {
                        File.AppendAllText(pathEnd, $"{i + 1}-й поставщик с {j + 1}-м потребителем на {divisionArray[i, j]} ед. продукции", Encoding.UTF8);
                        File.AppendAllText(pathEnd, Environment.NewLine);
                    }
                }
            }
        }
    }
}
