﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Windows.Forms;

namespace ПервоначальноеРаспределениеПоСЗ
{
    internal class FileWork
    {
        public static string pathStart; // Путь к исходному файлу
        public static string pathEnd; // Путь к конечному файлу
        public void VvodNameFile()
        {
            char otv; // Переменная для диалога
            while (true)
            {
                Console.WriteLine("После нажатия Enter, Вам необходимо указать csv файл где хранятся входные данные");
                Console.ReadKey();
                OpenFileDialog OD = new OpenFileDialog();
                OD.DefaultExt = ".csv";
                OD.Filter = "Text documents (.csv)|*.csv";
                if (OD.ShowDialog() == DialogResult.OK)
                {
                    pathStart = OD.FileName;
                    break;
                }
                else
                {
                    while (true)
                    {
                        try
                        {
                            Console.Write("\nЖелаете повторить выбор входных данных?\nДа(Y)/Нет(N)\nОтвет: ");
                            otv = Convert.ToChar(Console.ReadLine());
                            break;
                        }
                        catch
                        {
                            Console.WriteLine("Введены некорректные данные!");
                        }
                    }
                    if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                    {
                        return;
                    }
                }
            }
        }
        public static void SaveNameFile() // Определение файла для вывода результатов
        {
            char otv; // Переменная для диалога с пользователем
            while (true)
            {
                Console.WriteLine("После нажатия Enter, Вам необходимо указать csv файл куда будет сохранён результат");
                Console.ReadKey();
                SaveFileDialog OD = new SaveFileDialog();
                OD.DefaultExt = ".csv";
                OD.Filter = "Text documents (.csv)|*.csv";
                if (OD.ShowDialog() == DialogResult.OK)
                {
                    pathEnd = OD.FileName;
                    break;
                }
                else
                {
                    while (true)
                    {
                        try
                        {
                            Console.Write("\nЖелаете повторить выбор файла?\nДа(Y)/Нет(N)\nОтвет: ");
                            otv = Convert.ToChar(Console.ReadLine());
                            break;
                        }
                        catch
                        {
                            Console.WriteLine("Введены некорректные данные!");
                        }
                    }
                    if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                    {
                        return;
                    }
                }
            }
        }
        public string[,] GetData()
        {
            var lines = File.ReadAllLines(pathStart);
            string[][] text = new string[lines.Length][];
            for (int i = 0; i < text.Length; i++)
            {
                text[i] = lines[i].Split(';');
            }
            string[,] d = new string[text.Length, text[text.Length - 1].Length];
            int j = 0;
            int k;
            foreach (string[] line in text)
            {
                k = 0;
                foreach (string s in line)
                {
                    d[j, k] = s;
                    k++;
                }
                j++;
            }
            return d;
        }
        public bool Proverka(string[,] a) // Проверка входных данных на правильность
        {
            for (int i = 0; i < a.GetLength(0); i++)
            {
                for (int j = 0; j < a.GetLength(1); j++)
                {
                    if (i == 0 && j == 0)
                    {
                        j++;
                    }
                    try
                    {
                        if (Convert.ToDouble(a[i, j]) <= 0)
                        {
                            Console.WriteLine("В таблицы распределений, не могут быть отрицательные значения или 0");
                            return true;
                        }
                    }
                    catch
                    {
                        Console.WriteLine("Во входных данных присутствуют некоректные данные, исправьте их и попробуйте снова");
                        return true;
                    }
                }
            }
            return false;
        }
        public void Record(string[,] a, double summa) // Запись данных в csv файл
        {
            for (int i = 0; i < a.GetLength(0); i++)
            {
                for (int j = 0; j < a.GetLength(1); j++)
                {
                    File.AppendAllText(pathEnd, a[i, j] + ";", Encoding.UTF8);
                }
                File.AppendAllText(pathEnd, Environment.NewLine);
            }
            File.AppendAllText(pathEnd, Environment.NewLine);
            File.AppendAllText(pathEnd, "\nF =;" + summa + " у. д. е.;", Encoding.UTF8);
            File.AppendAllText(pathEnd, Environment.NewLine);
            int p = 1; // Переменная хранящая номер записи
            // Циклы для прохождения по массиву распределения
            for (int i = 0; i < a.GetLength(0); i++)
            {
                for (int j = 0; j < a.GetLength(1); j++)
                {
                    if (i == 0 && j == 0)
                    {
                        j++;
                    }
                    string str = a[i, j]; // Переменная для хранения содержимого ячейки
                    int k = 0; // Количесво символов / в ячейке
                    int index = 0; // Переменная, которая хранит индекс символа |
                    for (int e = 0; e < str.Length; e++)
                    {
                        if (str[e] == '|')
                        {
                            k++;
                            index = e;
                        }
                    }
                    if (k != 0) // Если в ячейке есть символ |
                    {
                        // Вывод записи кому и с кем нужно заключить договор
                        File.AppendAllText(pathEnd, p + ") " + i + " поставщику требуется заключить договор с " + j + " магазином на поставку " + str.Substring(index + 1) + " единиц продукции\n", Encoding.UTF8);
                        File.AppendAllText(pathEnd, Environment.NewLine);
                        p++;
                    }
                }
            }
        }
    }
}
