﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Симлекс_метод
{
    internal class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            while (true)
            {
                char otv;
                FileWork fileWork = new FileWork();
                Simplex simplex = new Simplex();
                while (true)
                {
                    Console.WriteLine("После нажатия Enter, Вам необходимо указать csv файл где хранятся входные данные");
                    Console.ReadKey();
                    OpenFileDialog OD = new OpenFileDialog();
                    OD.DefaultExt = ".csv";
                    OD.Filter = "Text documents (.csv)|*.csv";
                    if (OD.ShowDialog() == DialogResult.OK)
                    {
                        fileWork.pathStart = OD.FileName;
                        break;
                    }
                    else
                    {
                        while (true)
                        {
                            try
                            {
                                Console.Write("\nЖелаете повторить выбор входных данных?\nДа(Y)/Нет(N)\nОтвет: ");
                                otv = Convert.ToChar(Console.ReadLine());
                                break;
                            }
                            catch
                            {
                                Console.WriteLine("Введены некорректные данные!");
                            }
                        }
                        if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                        {
                            return;
                        }
                    }
                }
                double[,] main = new double[0, 0]; // Расход сырья на единицу продуции
                double[] res = new double[0]; // Запасы сырья
                double[] dohod = new double[0]; // Доход от реализации единицы продукции
                int n = 0; // Количество продукции
                int m = 0; // Количество ресурсов
                if (fileWork.Proverka() == true)
                {
                    Console.ReadKey();
                    break;
                }
                fileWork.GetData(ref n, ref m, ref main, ref res, ref dohod);
                simplex.Vvod(ref dohod);
                int temp = main.GetLength(1) + 1; // Дополнительная переменная в СО
                int dop = temp; // Дополнительная переменная для вывода в граничных условиях
                simplex.MatModel(dohod, main, res); // Вывод математической модели
                simplex.KanModel(dohod, main, res, temp, dop); // Вывод кананической модели

                // Сборка первой симплекс таблицы
                double[,] Table = new double[main.GetLength(0) + 1, main.GetLength(1) + main.GetLength(0) + 1]; // Массив симплекс-таблицы
                temp = main.GetLength(1);
                simplex.FirstTable(main, ref Table, res, dohod, ref temp);

                //промежуточные
                double[] ans = new double[0]; // Количество 
                simplex.intermediate(Table, ref ans, 0);

                //поиск индексов решающего элемента
                bool check = false;
                int col, row; // Разрешающий столбец и строка
                int o = 0;
                while (true)
                {
                    col = simplex.decisiveColumn(Table); // Нахождение разрешающего столбца
                    row = simplex.decisiveRow(Table, col); // Нахождение разрешающей строки

                    Console.WriteLine($"Разрешающий столбец: {col + 1}");
                    Console.WriteLine($"Разрешающая строка: {row + 1}");

                    simplex.solve(ref Table, row, col); // Преобразование симплекс-таблицы

                    simplex.intermediate(Table, ref ans, o + 1); // Вывод промежуточных результатов

                    for (int j = 0; j < Table.GetLength(1); j++)
                    {
                        if (Table[Table.GetLength(0) - 1, j] > 0 && Table[Table.GetLength(0) - 1, j] != 0)
                        {
                            check = false;
                            break;
                        }
                        else
                        {
                            check = true;
                        }
                    }
                    if (check)
                    {
                        break;
                    }
                    o++;
                }
                simplex.finalResults(main.GetLength(1), ans, Table);
                Console.ReadKey();
                Console.Clear();
                while (true)
                {
                    Console.WriteLine("После нажатия Enter, Вам необходимо указать csv файл куда будет сохранён результат");
                    Console.ReadKey();
                    SaveFileDialog OD = new SaveFileDialog();
                    OD.DefaultExt = ".csv";
                    OD.Filter = "Text documents (.csv)|*.csv";
                    if (OD.ShowDialog() == DialogResult.OK)
                    {
                        fileWork.pathEnd = OD.FileName;
                        break;
                    }
                    else
                    {
                        while (true)
                        {
                            try
                            {
                                Console.Write("\nЖелаете повторить выбор файла?\nДа(Y)/Нет(N)\nОтвет: ");
                                otv = Convert.ToChar(Console.ReadLine());
                                break;
                            }
                            catch
                            {
                                Console.WriteLine("Введены некорректные данные!");
                            }
                        }
                        if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                        {
                            return;
                        }
                    }
                }
                fileWork.Conclusion(main.GetLength(1), ans, Table);
                while (true)
                {
                    try
                    {
                        Console.Write("\nПовторить программу?\nДа(Y)/Нет(N)\nОтвет: ");
                        otv = Convert.ToChar(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
                if (!(otv.Equals('Y') || otv.Equals('y') || otv.Equals('н') || otv.Equals('Н')))
                {
                    break;
                }
                else if (!(otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                {
                    Console.Clear();
                }
                else
                {
                    Console.Clear();
                }
            }
        }
    }
}
