﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Симлекс_метод
{
    internal class Simplex
    {
        public void Vvod(ref double[] dohod) // Ввод прибыли от продукции
        {
            for (int i = 0; i < dohod.Length; i++)
            {
                while (true)
                {
                    try
                    {
                        while (true)
                        {
                            Console.Write($"Введите прибыль с реалзации продукта №{i + 1}: ");
                            double h = Convert.ToDouble(Console.ReadLine());
                            if (h >= 0)
                            {
                                dohod[i] = h;
                                break;
                            }
                            else
                            {
                                Console.WriteLine("Прибыль должна быть больше нуля\nПовторите ввод");
                            }
                        }
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Необходимо ввести целое число!\nПовторите ввод");
                    }
                }
            }
        }
        public void MatModel(double[] dohod, double[,] main, double[] res) // Вывод математической модели
        {
            Console.WriteLine("Математическая модель:");
            Console.Write("\tF = ");
            for (int i = 0; i < dohod.Length; i++)
            {
                if (i != dohod.Length - 1)
                {
                    Console.Write($"{dohod[i]}x{i + 1} + ");
                }
                else
                {
                    Console.Write($"{dohod[i]}x{i + 1} -> max\n");
                }
            }
            for (int i = 0; i < main.GetLength(0); i++)
            {
                Console.Write("\t");
                for (int j = 0; j < main.GetLength(1); j++)
                {
                    if (j != main.GetLength(1) - 1)
                    {
                        Console.Write($"{main[i, j]}x{j + 1} + ");
                    }
                    else
                    {
                        Console.Write($"{main[i, j]}x{j + 1} <= {res[i]}");
                    }
                }
                Console.WriteLine();
            }
            Console.Write($"\tx");
            for (int i = 0; i < main.GetLength(1); i++)
            {
                if (i != main.GetLength(1) - 1)
                {
                    Console.Write($"{i + 1},");
                }
                else
                {
                    Console.Write($"{i + 1}");
                }
            }
            Console.WriteLine($" >= 0\n");
        }
        public void KanModel(double[] dohod, double[,] main, double[] res, int temp, int dop) // Вывод кананической модели
        {
            Console.WriteLine("Каноническая задача минимизации, составленная по условию задачи:");
            Console.Write("\tF' = -(");
            for (int i = 0; i < dohod.Length; i++)
            {
                if (i != dohod.Length - 1)
                {
                    Console.Write($"{dohod[i]}x{i + 1} + ");
                }
                else
                {
                    Console.Write($"{dohod[i]}x{i + 1}) -> min\n");
                }
            }
            for (int i = 0; i < main.GetLength(0); i++)
            {
                Console.Write("\t");
                for (int j = 0; j < main.GetLength(1); j++)
                {
                    if (j != main.GetLength(1) - 1)
                    {
                        Console.Write($"{main[i, j]}x{j + 1} + ");
                    }
                    else
                    {
                        Console.Write($"{main[i, j]}x{j + 1} + x{temp++} = {res[i]}");
                    }
                }
                Console.WriteLine();
            }
            Console.Write($"\tx");
            for (int i = 0; i < main.GetLength(1); i++)
            {
                if (i == main.GetLength(1) - 1)
                {
                    Console.Write($"{i + 1}");
                }
                else
                {
                    Console.Write($"{i + 1},");
                }
            }
            Console.Write($" >= 0; x");
            while (dop != temp)
            {
                if (dop + 1 != temp)
                {
                    Console.Write($"{dop},");
                }
                else
                {
                    Console.Write($"{dop}");
                }
                dop++;
            }
            Console.WriteLine(" - любое\n");
        }
        public void finalResults(double r, double[] a, double[,] b) // Вывод оканчательных результатов
        {
            Console.WriteLine("\nОкончательные результаты:");
            for (int i = 0; i < r; i++)
            {
                Console.WriteLine($"x{i + 1} = {a[i]}");
            }
            Console.WriteLine($"F = {Math.Round(Math.Abs(b[b.GetLength(0) - 1, b.GetLength(1) - 1]), 3)}");
        }
        public void solve(ref double[,] a, int row, int col) // Преобразование столбца к единичному
        {
            double var = a[row, col]; // Разрешающий элемент
            for (int j = 0; j < a.GetLength(1); j++) // Разделение строки с разрешающим элементом на разрешающий элемент
            {
                a[row, j] = (double)(a[row, j] / var);
            }
            double del; // Переменная для хранеия элемента в строке, которую юудем занулять
            for (int i = 0; i < a.GetLength(0); i++)
            {
                del = a[i, col];
                for (int j = 0; j < a.GetLength(1); j++) // Зануляем эелемент на главном столбце
                {
                    if (i != row) // Если это не разрешающая строка
                    {
                        var = a[row, j];
                        var *= -del;
                        a[i, j] += var;
                    }
                }
            }
        }

        public int decisiveRow(double[,] a, int b) // Нахождение разрешающей строки
        {
            double[,] a1 = new double[a.GetLength(0), a.GetLength(1)];
            for (int i = 0; i < a1.GetLength(0); i++)
            {
                for (int j = 0; j < a1.GetLength(1); j++)
                {
                    a1[i, j] = Convert.ToDouble(a[i, j]);
                }
            }
            double min = double.MaxValue;
            int temp = 0;
            for (int i = 0; i < a1.GetLength(0) - 1; i++)
            {
                if (a1[i, a1.GetLength(1) - 1] != 0 && a1[i, b] > 0)
                {
                    if ((a1[i, a1.GetLength(1) - 1] / a1[i, b]) < min)
                    {
                        min = a1[i, a1.GetLength(1) - 1] / a1[i, b];
                        temp = i;
                    }
                }
            }
            return temp;
        }

        public int decisiveColumn(double[,] a) // Нахождение разрешающего столбца
        {
            double max = double.MinValue;
            int temp = 0;
            for (int j = 0; j < a.GetLength(1); j++)
            {
                if (a[a.GetLength(0) - 1, j] >= 0)
                {
                    if (a[a.GetLength(0) - 1, j] > max)
                    {
                        max = a[a.GetLength(0) - 1, j];
                        temp = j;
                    }
                }
            }
            return temp;
        }

        public void FirstTable(double[,] main, ref double[,] Table, double[] res, double[] dohod, ref int temp) // Формирование первой симплекс таблицы
        {
            for (int i = 0; i < main.GetLength(0); i++)
            {
                for (int j = 0; j < main.GetLength(1); j++)
                {
                    if (j != main.GetLength(1) - 1)
                    {
                        Table[i, j] = main[i, j];
                    }
                    else
                    {
                        Table[i, j] = main[i, j];
                        Table[i, temp++] = 1;
                    }
                }
            }
            for (int i = 0; i < res.Length; i++) // Вывод в столбец свободных членов
            {
                Table[i, Table.GetLength(1) - 1] = res[i];
            }
            for (int i = 0; i < dohod.Length; i++) // Вывод в строку оценок
            {
                Table[Table.GetLength(0) - 1, i] = dohod[i];
            }
        }
        public void intermediate(double[,] a, ref double[] b, int o) // Вывод симплекс-таблицы и промежуточных результатов
        {
            Array.Resize(ref b, 0);
            if (o == 0)
            {
                Console.WriteLine($"\n1-ая симплекс-таблица:");
            }
            else
            {
                Console.WriteLine($"\n{o + 1}-я Симплекс-таблица:");
            }

            for (int i = 0; i < a.GetLength(0); i++) // Вывод симлекс-таблицы
            {
                for (int j = 0; j < a.GetLength(1); j++)
                {
                    Console.Write($"{a[i, j]:f3} ");
                }
                Console.WriteLine();
            }
            Console.WriteLine("\nРезультаты таблицы:");
            int temp = 0; // Количество 0 в столбце
            int temp2 = 0; // Количество 1 в столбце
            for (int j = 0; j < a.GetLength(1) - 1; j++) // Зполнение дополниетльной переменной значениями x
            {
                temp = 0;
                temp2 = 0;
                for (int i = 0; i < a.GetLength(0) - 1; i++) // Подсчёт количества 0 и 1 в столбце
                {
                    if (a[i, j] == 0)
                        temp++;
                    if (a[i, j] == 1)
                        temp2++;
                }
                if (temp == a.GetLength(0) - 2 && temp2 == 1) // Если столбце единичный
                {
                    for (int i = 0; i < a.GetLength(0) - 1; i++)
                    {
                        if (a[i, j] == 1)
                        {
                            temp = i;
                        }
                    }
                    Array.Resize(ref b, b.Length + 1);
                    b[b.Length - 1] = Math.Round(a[temp, a.GetLength(1) - 1],3);
                }
                else // Если столбец не единичный
                {
                    Array.Resize(ref b, b.Length + 1);
                    b[b.Length - 1] = 0;
                }
            }
            for (int i = 0; i < b.Length; i++) // Вывод значений x
            {
                Console.WriteLine($"x{i + 1} = {b[i]}");
            }
            Console.WriteLine($"F' = {Math.Round(a[a.GetLength(0) - 1, a.GetLength(1) - 1], 3)}");
            Console.WriteLine($"F = {Math.Round(Math.Abs(a[a.GetLength(0) - 1, a.GetLength(1) - 1]), 3)}");
        }
    }
}
